diff --git a/mz_zip.c b/mz_zip.c
index c29f8679..a7d7ad5f 100644
--- a/mz_zip.c
+++ b/mz_zip.c
@@ -68,6 +68,7 @@
 #define MZ_ZIP_SIZE_LD_ITEM             (30)
 #define MZ_ZIP_SIZE_CD_ITEM             (46)
 #define MZ_ZIP_SIZE_CD_LOCATOR64        (20)
+#define MZ_ZIP_SIZE_MAX_DATA_DESCRIPTOR (24)
 
 #ifndef MZ_ZIP_EOCD_MAX_BACK
 #define MZ_ZIP_EOCD_MAX_BACK            (1 << 20)
@@ -1337,55 +1338,70 @@ static int32_t mz_zip_recover_cd(void *handle)
             mz_stream_seek(zip->stream, local_file_info.compressed_size, MZ_SEEK_CUR);
         }
 
-        /* Search for the next local header */
-        err = mz_stream_find(zip->stream, (const void *)local_header_magic, sizeof(local_header_magic),
-                INT64_MAX, &next_header_pos);
-        
-        if (err == MZ_EXIST_ERROR)
+        while (1)
         {
-            mz_stream_seek(zip->stream, compressed_pos, MZ_SEEK_SET);
-
-            /* Search for central dir if no local header found */
-            err = mz_stream_find(zip->stream, (const void *)central_header_magic, sizeof(central_header_magic),
-                INT64_MAX, &next_header_pos);
-
+            /* Search for the next local header */
+            err = mz_stream_find(zip->stream, (const void *)local_header_magic, sizeof(local_header_magic),
+                    INT64_MAX, &next_header_pos);
+        
             if (err == MZ_EXIST_ERROR)
             {
-                /* Get end of stream if no central header found */
-                mz_stream_seek(zip->stream, 0, MZ_SEEK_END);
-                next_header_pos = mz_stream_tell(zip->stream);
+                mz_stream_seek(zip->stream, compressed_pos, MZ_SEEK_SET);
+
+                /* Search for central dir if no local header found */
+                err = mz_stream_find(zip->stream, (const void *)central_header_magic, sizeof(central_header_magic),
+                    INT64_MAX, &next_header_pos);
+
+                if (err == MZ_EXIST_ERROR)
+                {
+                    /* Get end of stream if no central header found */
+                    mz_stream_seek(zip->stream, 0, MZ_SEEK_END);
+                    next_header_pos = mz_stream_tell(zip->stream);
+                }
+
+                eof = 1;
             }
 
-            eof = 1;
-        }
+            if (local_file_info.flag & MZ_ZIP_FLAG_DATA_DESCRIPTOR || local_file_info.compressed_size == 0)
+            {
+                /* Search backwards for the descriptor, seeking too far back will be incorrect if compressed size is small */
+                err = mz_stream_find_reverse(zip->stream, (const void *)descriptor_magic, sizeof(descriptor_magic),
+                            MZ_ZIP_SIZE_MAX_DATA_DESCRIPTOR, &descriptor_pos);
+                if (err == MZ_OK)
+                {
+                    if (mz_zip_extrafield_contains(local_file_info.extrafield,
+                        local_file_info.extrafield_size, MZ_ZIP_EXTENSION_ZIP64, NULL) == MZ_OK)
+                        zip64 = 1;
 
-        /* Search backwards for the descriptor */
-        err = mz_stream_find_reverse(zip->stream, (const void *)descriptor_magic, sizeof(descriptor_magic),
-                    INT8_MAX, &descriptor_pos);
-        if (err == MZ_OK)
-        {
-            if (mz_zip_extrafield_contains(local_file_info.extrafield,
-                local_file_info.extrafield_size, MZ_ZIP_EXTENSION_ZIP64, NULL) == MZ_OK)
-                zip64 = 1;
+                    err = mz_zip_entry_read_descriptor(zip->stream, zip64, &crc32,
+                        &compressed_size, &uncompressed_size);
 
-            err = mz_zip_entry_read_descriptor(zip->stream, zip64, &crc32,
-                &compressed_size, &uncompressed_size);
+                    if (err == MZ_OK)
+                    {
+                        if (local_file_info.crc == 0)
+                            local_file_info.crc = crc32;
+                        if (local_file_info.compressed_size == 0)
+                            local_file_info.compressed_size = compressed_size;
+                        if (local_file_info.uncompressed_size == 0)
+                            local_file_info.uncompressed_size = uncompressed_size;
+                    }
 
-            if (err == MZ_OK)
+                    compressed_end_pos = descriptor_pos;
+                }
+                else if (local_file_info.flag & MZ_ZIP_FLAG_DATA_DESCRIPTOR)
+                {
+                    /* Wrong local file entry found, keep searching */
+                    next_header_pos += 1;
+                    mz_stream_seek(zip->stream, next_header_pos, MZ_SEEK_SET);
+                    continue;
+                }
+            }
+            else
             {
-                if (local_file_info.crc == 0)
-                    local_file_info.crc = crc32;
-                if (local_file_info.compressed_size == 0)
-                    local_file_info.compressed_size = compressed_size;
-                if (local_file_info.uncompressed_size == 0)
-                    local_file_info.uncompressed_size = uncompressed_size;
+                compressed_end_pos = next_header_pos;
             }
 
-            compressed_end_pos = descriptor_pos;
-        }
-        else
-        {
-            compressed_end_pos = next_header_pos;
+            break;
         }
 
         compressed_size = compressed_end_pos - compressed_pos;
